<!----------------------------------------------------------------------------------------------------------------------
  -- Edit Plugins Modal
  --------------------------------------------------------------------------------------------------------------------->

<template>
    <div id="edit-plugins-modal">
        <BModal
            ref="editPluginsModal"
            size="xl"
            no-close-on-backdrop
            no-close-on-esc
            hide-header-close
            ok-only
            ok-variant="secondary"
            ok-title="Close"
            :busy="busy"
        >
            <template #title>
                <Fa icon="puzzle-piece-simple" />
                Edit Plugins
            </template>
            <BOverlay
                :show="busy"
                rounded
                opacity="0.6"
                variant="dark"
                spinner-variant="primary"
            >
                <BFormRow>
                    <BCol cols="3">
                        <BCard no-body>
                            <template #header>
                                <h6 class="mt-1">
                                    Plugins
                                </h6>
                            </template>
                            <BListGroup flush>
                                <BListGroupItem
                                    v-for="config in pluginConfigs"
                                    :key="config.plugin"
                                    :active="isActive(config.plugin)"
                                    @click="selectPlugin(config)"
                                >
                                    {{ config.plugin }}
                                </BListGroupItem>
                            </BListGroup>
                        </BCard>
                    </BCol>
                    <BCol cols="9">
                        <div v-if="!selectedPluginConfig" class="text-center">
                            <h4 class="text-center mt-4">
                                Please select a plugin to edit it's config.
                            </h4>
                        </div>
                        <BCard v-else no-body class="h-100">
                            <BTabs v-model="selectedTab" card class="h-100">
                                <template #tabs-end>
                                    <li class="ms-auto d-flex justify-content-end mb-2">
                                        <BButton
                                            variant="primary"
                                            :disabled="hasConfig"
                                            size="sm"
                                            @click="add()"
                                        >
                                            <Fa icon="add" class="me-1" />
                                            Add
                                        </BButton>
                                    </li>
                                </template>
                                <BTab title="System">
                                    <Component
                                        :is="pluginConfigEditor"
                                        v-if="selectedPluginConfig?.systemStorage"
                                        v-model:plugin-config="selectedPluginConfig"
                                        config-type="system"
                                        :disabled="!systemConfigEnabled"
                                        :environments="environments"
                                        :current-env-id="currentEnv?.id"
                                    />
                                    <div v-else class="text-center">
                                        <h5 class="text-center">
                                            No system config was found.  Click Add to create a new config.
                                        </h5>
                                    </div>
                                </BTab>
                                <BTab title="User" :disabled="!userConfigEnabled">
                                    <Component
                                        :is="pluginConfigEditor"
                                        v-if="selectedPluginConfig?.userStorage"
                                        v-model:plugin-config="selectedPluginConfig"
                                        config-type="system"
                                        :disabled="!userConfigEnabled"
                                        :environments="environments"
                                        :current-env-id="currentEnv?.id"
                                    />
                                    <div v-else class="text-center">
                                        <h5 class="text-center">
                                            No user config was found.  Click Add to create a new config.
                                        </h5>
                                    </div>
                                </BTab>
                            </BTabs>

                            <hr>

                            <div class="d-flex justify-content-between mx-2 mb-2">
                                <BButton
                                    variant="danger"
                                    :disabled="!hasConfig"
                                    @click="remove()"
                                >
                                    <Fa icon="trash" class="me-1" />
                                    Delete
                                </BButton>
                                <BButton
                                    variant="success"
                                    :disabled="!hasConfig"
                                    @click="save()"
                                >
                                    <Fa icon="save" class="me-1" />
                                    Save
                                </BButton>
                            </div>
                        </BCard>
                    </BCol>
                </BFormRow>
            </BOverlay>
        </BModal>
    </div>
</template>

<!--------------------------------------------------------------------------------------------------------------------->

<style lang="scss">
</style>

<!--------------------------------------------------------------------------------------------------------------------->

<script lang="ts" setup>
    import { computed, ref } from 'vue';
    import { useObservable } from '../../lib/composables/rxjs.js';
    import { cloneDeep } from 'lodash';

    // Models
    import { BModal } from 'bootstrap-vue-next';
    import { SSTPluginStorage } from '../../../common/interfaces/plugins.js';

    // Managers
    import authMan from '../../lib/managers/auth.js';
    import envMan from '../../lib/managers/environments.js';
    import { hasPerm } from '../../lib/managers/permissions.js';
    import pluginMan, { SSTClientConfigPopulated } from '../../lib/managers/plugin.js';

    // Components
    import PluginConfigEditor from './pluginConfigEditor.vue';

    //------------------------------------------------------------------------------------------------------------------
    // Refs
    //------------------------------------------------------------------------------------------------------------------

    const busy = ref(false);
    const editPluginsModal = ref<typeof BModal | null>(null);
    const selectedPluginConfig = ref<SSTClientConfigPopulated | null>(null);
    const selectedTab = ref<number>(0);

    //------------------------------------------------------------------------------------------------------------------
    // Observables
    //------------------------------------------------------------------------------------------------------------------

    const account = useObservable(authMan.account$);
    const authEnabled = useObservable(authMan.authEnabled$);
    const pluginConfigs = useObservable(pluginMan.configs$);
    const environments = useObservable(envMan.environments$);
    const currentEnv = useObservable(envMan.currentEnv$);

    //------------------------------------------------------------------------------------------------------------------
    // Computed
    //------------------------------------------------------------------------------------------------------------------

    const pluginConfigEditor = computed(() =>
    {
        return selectedPluginConfig.value?.pluginConfigEditor ?? PluginConfigEditor;
    });

    const canModifySystem = computed(() =>
    {
        return authEnabled.value
            ? !!(account.value && hasPerm(account.value, 'canUpdate/SystemPluginStorage'))
            : true;
    });

    const userConfigEnabled = computed(() => authEnabled.value);
    const systemConfigEnabled = computed(() => !authEnabled.value || canModifySystem.value);

    const activeConfig = computed(() : 'system' | 'user' =>
    {
        return selectedTab.value === 0 ? 'system' : 'user';
    });

    const storage = computed({
        get()
        {
            return activeConfig.value === 'user'
                ? selectedPluginConfig.value?.userStorage
                : selectedPluginConfig.value?.systemStorage;
        },
        set(val)
        {
            if(selectedPluginConfig.value)
            {
                if(activeConfig.value === 'user')
                {
                    selectedPluginConfig.value.userStorage = val;
                }
                else
                {
                    selectedPluginConfig.value.systemStorage = val;
                }
            }
        },
    });

    const hasConfig = computed(() =>
    {
        return !!storage.value;
    });

    //------------------------------------------------------------------------------------------------------------------
    // Methods
    //------------------------------------------------------------------------------------------------------------------

    function isActive(plugin : string) : boolean
    {
        return plugin === (selectedPluginConfig.value?.plugin ?? '');
    }

    function selectPlugin(config ?: SSTClientConfigPopulated) : void
    {
        selectedPluginConfig.value = cloneDeep(config);
    }

    async function remove() : Promise<void>
    {
        if(selectedPluginConfig.value)
        {
            busy.value = true;

            const accountId = activeConfig.value === 'user' ? authMan.account?.id : null;
            await pluginMan.removeStorage(selectedPluginConfig.value.plugin, accountId);
            await pluginMan.loadStorages();
            selectedPluginConfig.value = undefined;

            await new Promise((resolve) => setTimeout(resolve, 500));
            busy.value = false;
        }
    }

    function add() : void
    {
        if(!storage.value)
        {
            storage.value = pluginMan.getStorageDefaults(selectedPluginConfig.value, storage.value);
        }
    }

    async function save() : Promise<void>
    {
        if(selectedPluginConfig.value)
        {
            busy.value = true;

            const record : SSTPluginStorage = {
                plugin: selectedPluginConfig.value.plugin,
                accountId: activeConfig.value === 'user' ? authMan.account?.id : null,
                storage: storage.value,
            };

            await pluginMan.addUpdateStore(record);
            await pluginMan.loadStorages();

            await new Promise((resolve) => setTimeout(resolve, 500));
            busy.value = false;
        }
    }

    async function show() : Promise<void>
    {
        selectedPluginConfig.value = undefined;
        selectedTab.value = authEnabled.value ? 1 : 0;
        editPluginsModal.value?.show();
        await pluginMan.loadStorages();
    }

    //------------------------------------------------------------------------------------------------------------------

    defineExpose({
        show,
    });
</script>

<!--------------------------------------------------------------------------------------------------------------------->
